Imports System.IO

Public Class FormMain

    Private Const XmlFileName As String = "vbmailparam.xml"
    Private Id As String = ""
    Private Password As String = ""
    Private FirstFlag As Boolean = True
    Private MailParam As MailParameter

    Private Sub ListMail_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListMail.SelectedIndexChanged
        If ListMail.SelectedItems.Count > 0 Then
            Dim no As Integer = ListMail.SelectedIndices.Item(0) + 1
            If no > 0 Then
                Dim pop As nMail.Pop3 = New nMail.Pop3(MailParam.Pop3)
                nMail.Options.EnableDecodeBody()
                nMail.Options.EnableDecodeHeader()
                Try
                    pop.SSL = MailParam.Pop3Ssl
                    pop.Connect(MailParam.Pop3Port)
                    pop.Authenticate(Id, Password, MailParam.Apop)
                    pop.GetMail(no)
                    TextBody.Text = pop.Body
                Catch nex As nMail.nMailException
                    If nex.ErrorCode = nMail.Pop3.ErrorAuthenticate Then
                        MessageBox.Show(String.Format("F؃G[łB{0}{1}", ControlChars.NewLine, nex.Message))
                        Id = ""
                        Password = ""
                    Else
                        MessageBox.Show("T[o[ڑɃG[܂B{0}", nex.Message)
                    End If
                Catch ex As Exception
                    Debug.WriteLine(ex.Message)
                Finally
                    pop.Dispose()
                End Try
            End If
        End If
    End Sub

    Private Sub MenuRedisp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuRedisp.Click
        FirstFlag = False
        GetMailList()
    End Sub

    Private Sub MenuCreate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuCreate.Click
        Dim form As FormWrite = New FormWrite

        form.HostName = MailParam.Smtp
        form.From = MailParam.Address
        form.SSL = MailParam.SmtpSsl
        form.PortNo = MailParam.SmtpPort
        form.Auth = MailParam.SmtpAuth
        form.Id = Id
        form.Password = Password
        form.ShowDialog()
    End Sub

    Private Sub MenuSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuSave.Click
        If ListMail.SelectedItems.Count > 0 Then
            Dim no As Integer = ListMail.SelectedItems(0).Index + 1
            If SaveFileDialog.ShowDialog() = DialogResult.OK Then
                If SaveFileDialog.FileName <> "" Then
                    If no > 0 Then
                        Dim pop As nMail.Pop3 = New nMail.Pop3(MailParam.Pop3)
                        nMail.Options.DisableDecodeBodyAll()
                        nMail.Options.DisableDecodeHeader()

                        Try
                            pop.SSL = MailParam.Pop3Ssl
                            pop.Connect(MailParam.Pop3Port)
                            pop.Authenticate(Id, Password, MailParam.Apop)
                            pop.GetMail(no)
                            Dim writer As StreamWriter = New StreamWriter(SaveFileDialog.FileName)
                            writer.Write(pop.Header)
                            writer.Write(ControlChars.CrLf)
                            writer.Write(pop.Body)
                            writer.Close()
                        Catch nex As nMail.nMailException
                            If nex.ErrorCode = nMail.Pop3.ErrorAuthenticate Then
                                MessageBox.Show(String.Format("F؃G[łB{0}{1}", ControlChars.NewLine, nex.Message))
                                Id = ""
                                Password = ""
                            Else
                                MessageBox.Show("T[o[ڑɃG[܂B{0}", nex.Message)
                            End If
                        Catch ex As Exception
                            Debug.WriteLine(ex.Message)
                        Finally
                            pop.Dispose()
                        End Try
                    End If
                End If
            End If
        End If
    End Sub

    Private Sub MenuUnite_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuUnite.Click
        Dim form As FormUnite = New FormUnite

        form.ShowDialog()
    End Sub

    Private Sub MenuDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuDelete.Click
        If ListMail.SelectedItems.Count > 0 Then
            Dim no As Integer = ListMail.SelectedItems(0).Index + 1
            If no > 0 Then
                Dim pop As nMail.Pop3 = New nMail.Pop3(MailParam.Pop3)
                Try
                    pop.SSL = MailParam.Pop3Ssl
                    pop.Connect(MailParam.Pop3Port)
                    pop.Authenticate(Id, Password, MailParam.Apop)
                    pop.Delete(no)
                    MessageBox.Show("[폜܂B")
                Catch nex As nMail.nMailException
                    If nex.ErrorCode = nMail.Pop3.ErrorAuthenticate Then
                        MessageBox.Show(String.Format("F؃G[łB{0}{1}", ControlChars.NewLine, nex.Message))
                        Id = ""
                        Password = ""
                    Else
                        MessageBox.Show("T[o[ڑɃG[܂B{0}", nex.Message)
                    End If
                Catch ex As Exception
                    Debug.WriteLine(ex.Message)
                Finally
                    pop.Dispose()
                End Try
                GetMailList()
            End If
        End If
    End Sub

    Private Sub MenuExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuExit.Click
        Close()
    End Sub

    Private Sub FormMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        MailParam = New MailParameter
        MailParam.Pop3 = ""
        MailParam.Pop3Port = nMail.Pop3.StandardPortNo
        MailParam.Pop3Ssl = 0
        MailParam.Smtp = ""
        MailParam.SmtpPort = nMail.Smtp.StandardPortNo
        MailParam.SmtpSsl = 0
        MailParam.SmtpAuth = 0
        MailParam.Address = ""
        MailParam.Apop = False
        If File.Exists(XmlFileName) Then
            Dim serializer As System.Xml.Serialization.XmlSerializer = New System.Xml.Serialization.XmlSerializer(GetType(MailParameter))
            Dim fs As FileStream = New FileStream(XmlFileName, FileMode.Open)
            MailParam = CType(serializer.Deserialize(fs), MailParameter)
            fs.Close()
        End If
        nMail.Winsock.Initialize()
        ' HTML p[gt@Cɕۑ
        nMail.Options.EnableSaveHtmlFile()
    End Sub

    Private Sub FormMain_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        nMail.Winsock.Done()
    End Sub

    Private Sub GetMailList()
        If Id = "" Then
            If Not InputId() Then
                Return
            End If
            Application.DoEvents()
        End If
        ListMail.Items.Clear()
        Dim pop As nMail.Pop3 = New nMail.Pop3(MailParam.Pop3)
        Try
            pop.SSL = MailParam.Pop3Ssl
            pop.Connect(MailParam.Pop3Port)
            pop.Authenticate(Id, Password, MailParam.Apop)
            ListMail.BeginUpdate()
            Dim no As Integer
            For no = 1 To pop.Count
                pop.GetStatus(no)
                Dim item() As String = {pop.Subject, pop.From, pop.DateString}
                ListMail.Items.Add(New ListViewItem(item))
            Next no
        Catch nex As nMail.nMailException
            If nex.ErrorCode = nMail.Pop3.ErrorAuthenticate Then
                MessageBox.Show(String.Format("F؃G[łB{0}{1}", ControlChars.NewLine, nex.Message))
                Id = ""
                Password = ""
            Else
                MessageBox.Show("T[o[ڑɃG[܂B{0}", nex.Message)
            End If
        Catch ex As Exception
            Debug.WriteLine(ex.Message)
        Finally
            ListMail.EndUpdate()
            pop.Dispose()
        End Try
    End Sub

    Private Sub FormMain_Activated(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Activated
        If FirstFlag Then
            FirstFlag = False
            If (MailParam.Pop3 = "") Or (MailParam.Pop3Port = 0) Then
                MenuOption_Click(sender, e)
            End If
            If MailParam.Pop3 <> "" Then
                GetMailList()
            End If
        End If
    End Sub

    Private Function InputId() As Boolean
        Dim form As FormId = New FormId

        form.Id = Id
        form.Password = Password
        If form.ShowDialog() = DialogResult.OK Then
            Id = form.Id
            Password = form.Password

            Return True
        Else
            Return False
        End If
    End Function

    Private Sub MenuOption_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuOption.Click
        Dim form As FormOption = New FormOption

        form.Pop3 = MailParam.Pop3
        form.Pop3Port = MailParam.Pop3Port
        form.Pop3Ssl = MailParam.Pop3Ssl
        form.Smtp = MailParam.Smtp
        form.SmtpPort = MailParam.SmtpPort
        form.SmtpSsl = MailParam.SmtpSsl
        form.SmtpAuth = MailParam.SmtpAuth
        form.Address = MailParam.Address
        form.Apop = MailParam.Apop
        If form.ShowDialog() = DialogResult.OK Then
            MailParam.Pop3 = form.Pop3
            MailParam.Pop3Port = form.Pop3Port
            MailParam.Pop3Ssl = form.Pop3Ssl
            MailParam.Smtp = form.Smtp
            MailParam.SmtpPort = form.SmtpPort
            MailParam.SmtpSsl = form.SmtpSsl
            MailParam.SmtpAuth = form.SmtpAuth
            MailParam.Address = form.Address
            MailParam.Apop = form.Apop

            Dim serializer As System.Xml.Serialization.XmlSerializer = New System.Xml.Serialization.XmlSerializer(GetType(MailParameter))
            Dim fs As FileStream = New FileStream(XmlFileName, FileMode.Create)
            serializer.Serialize(fs, MailParam)
            fs.Close()
        End If
    End Sub
End Class

Public Class MailParameter
    Public Smtp As String
    Public SmtpPort As Integer
    Public SmtpSsl As Integer
    Public SmtpAuth As Integer
    Public Pop3 As String
    Public Pop3Port As Integer
    Public Pop3Ssl As Integer
    Public Address As String
    Public Apop As Boolean
End Class
